//===================================================================
// asb3000w.h
//-------------------------------------------------------------------
//
// ASB-3000 Wrapper
//
//===================================================================
#pragma once

namespace SampleAsb3000 {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Runtime::InteropServices;

	public ref class Asb3000
	{
		public:
			//-----------------------------------------------------------------
			// foCXANZXɊւ`
			//-----------------------------------------------------------------
			literal int	MAX_DEVICE				= 16;			// őfoCX
			literal int	DEVICE_AUTO				= -1;			// foCXw
			//-----------------------------------------------------------------
			// `lɊւ`
			//-----------------------------------------------------------------
			literal int	NUM_CH					= 2;			// Ή`l
			literal int	CH1						= 0;			// CH1
			literal int	CH2						= 1;			// CH2
			//-----------------------------------------------------------------
			// foCXɊւ`
			//-----------------------------------------------------------------
			literal int	VID_LENGTH				= 8;			// x_ʕ
			literal int	PID_LENGTH				= 16;			// v_Ngʕ
			//-----------------------------------------------------------------
			// TvOXe[^X̒`
			//-----------------------------------------------------------------
			literal int	STS_STOP				= 0x0;			// CxgȂ(~)
			literal int	STS_PRE_TRIG			= 0x1;			// gK҂ɂȂȌ
			literal int	STS_WAIT_FOR_TRIG		= 0x3;			// gK҂̏
			literal int	STS_TRIG_DETECT			= 0x7;			// gK|
			literal int	STS_AUTO_RUN			= 0xB;			// ^CAEgt[ōăX^[g
			//-----------------------------------------------------------------
			// G[R[h̒`
			//-----------------------------------------------------------------
			literal int	SUCCESS					= 0;			// ُȂ
			literal int	ERR_SYSTEM				= 1;			// VXeG[
			literal int	ERR_NO_DEVICE			= 2;			// gp\ȃfoCX܂
			literal int	ERR_IN_USE				= 3;			// w̃foCX͎gpł
			literal int	ERR_INVALID_DEVICENO	= 4;			// sȃfoCXʔԍł
			literal int	ERR_INVALID_ARGUMENT	= 5;			// sȈw肳܂
			literal int	ERR_INTERNAL			= 6;			// G[ł
			literal int	ERR_TRANSFER_TIMEOUT	= 7;			// f[^]^CAEgɂȂ܂
			literal int	ERR_TRANSFER_CANCEL		= 8;			// f[^]LZ܂
			literal int	ERR_TRANSFER_FAIL		= 9;			// f[^]s܂
			literal int	ERR_BUFF_OVERFLOW		= 10;			// obt@I[o[t[ł
			literal int	ERR_MEMSIZE				= 11;			// 擾TCYُł
			literal int	ERR_DEVICE				= 12;			// foCXG[ł
			//-----------------------------------------------------------------
			// bZ[W̒`
			//-----------------------------------------------------------------
			literal int	WM_DATA_READY			= 1;			// `f[^
			literal int	WM_DATA_THREAD_ERROR	= 2;			// f[^擾pXbhG[
			//-----------------------------------------------------------------
			// ̑̒`
			//-----------------------------------------------------------------
			literal int	DEVICE_ID				= 0xAB00;		// foCXID
			literal int	RES_VERT				= 1024;			// \(1024|Cg)
			literal int	RES_VOLTPOS				= 500;			// d|WV\
			literal int	ADBUFF_MAX_SIZE			= 1000000;		// ݍőf[^
			literal int	ADDATA_MASK_BIT			= 0x000003FF;	// rbg}XN
			//-----------------------------------------------------------------
			// eݒl̒`
			//-----------------------------------------------------------------
			// (d)XP[
			literal int	VOLTDIV_0				= 0;			// 10mV  or 100mV
			literal int	VOLTDIV_1				= 1;			// 20mV  or 200mV
			literal int	VOLTDIV_2				= 2;			// 50mV  or 500mV
			literal int	VOLTDIV_3				= 3;			// 100mV or 1V
			literal int	VOLTDIV_4				= 4;			// 200mV or 2V
			literal int	VOLTDIV_5				= 5;			// 500mV or 5V
			literal int	VOLTDIV_6				= 6;			// 1V    or 10V
			literal int	VOLTDIV_7				= 7;			// 2V    or 20V
			// v[u
			literal int	PROBE_X1				= 1;			// 1:1
			literal int	PROBE_X10				= 10;			// 10:1
			literal int PROBE_X100				= 100;			// 100:1
			// ͌
			literal int	CUP_DC					= 0;			// DC
			literal int	CUP_AC					= 1;			// AC
			// TCY
			literal int	MEMSIZE_10K				= 0;			// 10kPoint
			literal int	MEMSIZE_100K			= 1;			// 100kPoint
			literal int	MEMSIZE_1M				= 2;			// 1MPoint
			// ()XP[
			literal int	TIMEDIV_10NS			= 10;			// 10ns
			literal int	TIMEDIV_20NS			= 20;			// 20ns
			literal int	TIMEDIV_50NS			= 50;			// 50ns
			literal int	TIMEDIV_100NS			= 100;			// 100ns
			literal int	TIMEDIV_200NS			= 200;			// 200ns
			literal int	TIMEDIV_500NS			= 500;			// 500ns
			literal int	TIMEDIV_1US				= 1000;			// 1us
			literal int	TIMEDIV_2US				= 2000;			// 2us
			literal int	TIMEDIV_5US				= 5000;			// 5us
			literal int	TIMEDIV_10US			= 10000;		// 10us
			literal int	TIMEDIV_20US			= 20000;		// 20us
			literal int	TIMEDIV_50US			= 50000;		// 50us
			literal int	TIMEDIV_100US			= 100000;		// 100us
			literal int	TIMEDIV_200US			= 200000;		// 200us
			literal int	TIMEDIV_500US			= 500000;		// 500us
			literal int	TIMEDIV_1MS				= 1000000;		// 1ms
			literal int	TIMEDIV_2MS				= 2000000;		// 2ms
			literal int	TIMEDIV_5MS				= 5000000;		// 5ms
			literal int	TIMEDIV_10MS			= 10000000;		// 10ms
			// gш
			literal int	BW_FULL					= 0;			// FULL
			literal int	BW_20MHZ				= 1;			// 20MHz
			// TvO[h
			literal int	SMP_REAL				= 0;			// ATvO
			literal int	SMP_EQU					= 1;			// TvO
			// ANCWV[h
			literal int	ACQ_SINGLE				= 0;			// VOVbg
			literal int	ACQ_ROLL				= 1;			// [
			// gK[h
			literal int	TMODE_AUTO				= 0;			// I[g
			literal int	TMODE_NORMAL			= 1;			// m[}
			literal int	TMODE_FREERUN			= 2;			// t[
			// gK\[X
			literal int	TSRC_CH1				= 0;			// CH1
			literal int	TSRC_CH2				= 1;			// CH2
			literal int	TSRC_EXT				= 2;			// O
			// gK͌
			literal int	TCUP_DC					= 0;			// DC
			literal int	TCUP_LF					= 1;			// LFrej
			literal int	TCUP_HF					= 2;			// HFrej
			// gKX[v
			literal int	TSLP_POS				= 0;			// (オ)
			literal int	TSLP_NEG				= 1;			// ()
			// pXgK(pX)
			literal int	PULSE_NONE				= 0;			// gp
			literal int	PULSE_UNDER				= 1;			// pX
			literal int	PULSE_ABOVE				= 2;			// pXȏ

		public:
			//-------------------------------------------------------------------
			// foCX\
			//-------------------------------------------------------------------
			[StructLayout(LayoutKind::Sequential)]
			value class TDEVINFO
			{
				public:
					[MarshalAs(UnmanagedType::ByValArray, SizeConst = VID_LENGTH)]
					array<char> ^ VendorID;						// x_ʕ
					[MarshalAs(UnmanagedType::ByValArray, SizeConst = PID_LENGTH)]
					array<char> ^ ProductID;					// v_Ngʕ
					char	FirmVer;							// t@[EFÃo[W񕶎
					char	FpgaVer;							// FPGÃo[W񕶎
			};

		public:
			//-------------------------------------------------------------------
			// TvOp[^\
			//-------------------------------------------------------------------
			[StructLayout(LayoutKind::Sequential)]
			value class TSETMODE 
			{
				public:
					// 
					[MarshalAs(UnmanagedType::ByValArray, SizeConst = NUM_CH)]
					array<int> ^ dwVoltDiv;						// (d)XP[
					[MarshalAs(UnmanagedType::ByValArray, SizeConst = NUM_CH)]
					array<int> ^ dwVoltPos;						// (d)|WV
					[MarshalAs(UnmanagedType::ByValArray, SizeConst = NUM_CH)]
					array<int> ^ dwVertCoupling;				// ͌
					// 
					int		dwMemSize;							// TCY
					int		dwSamplingTime;						// ()XP[
					[MarshalAs(UnmanagedType::ByValArray, SizeConst = NUM_CH)]
					array<int> ^ dwBandWidth;					// gш
					int		dwSamplingMode;						// TvO[h
					int		dwAcqMode;							// ANCWV[h
					// gK
					int		dwTrigMode;							// gK[h
					int		dwTrigSource;						//	  "  \[X
					int		dwTrigCoupling;						//    "  ͌
					int		dwTrigSlope;						//    "  X[v
					int		dwTrigLevel;						//    "  x
					int		dwTrigPos;							//    "  |WV
					int		dwTrigDelay;						//    "  fBC
					int		dwTrigPulse;						// pXgK(pX)
					int		dwTrigPulseWidth;					//		"	   (pX)
			};

		public:
			//-------------------------------------------------------------------
			// API
			//-------------------------------------------------------------------
			// o[W擾
			[DllImport("asb3000.dll")]
			static bool Asb3000GetVersion(int* pdwDrvVer, int* pdwDllVer);
		
			// foCX̌
			[DllImport("asb3000.dll")]
			static bool Asb3000Create(short* pwDeviceNo, int hWnd, short uWMBase);
		
			// foCX̊J
			[DllImport("asb3000.dll")]
			static bool Asb3000Close(int wDeviceNo);
		
			// foCX擾
			[DllImport("asb3000.dll")]
			static bool Asb3000GetDevInfo(short wDeviceNo, TDEVINFO% pDevInfo);

			// TCY擾
			[DllImport("asb3000.dll")]
			static bool Asb3000GetMemSize(short wDeviceNo, int* pdwMemSize);

			// TvO샂[h̐ݒ
			[DllImport("asb3000.dll")]
			static bool Asb3000SetMode(short wDeviceNo, TSETMODE% pSetMode);

			// TvOJn
			[DllImport("asb3000.dll")]
			static bool Asb3000StartSampling(short wDeviceNo, int dwInitArg);

			// TvO~
			[DllImport("asb3000.dll")]
			static bool Asb3000StopSampling(short wDeviceNo);

			// TvOXe[^X擾
			[DllImport("asb3000.dll")]
			static bool Asb3000GetStatus(short wDeviceNo, int* pdwStatus, int* pdwNumData, int* pvInitArg);
		
			// TvOf[^擾
			[DllImport("asb3000.dll")]
			static bool Asb3000GetData(short wDeviceNo, int dwNumData, int* pData);
		
			// G[R[h
			[DllImport("asb3000.dll")]
			static int Asb3000GetLastError(short wDeviceNo);

			//-------------------------------------------------------------------
			// 		o[W擾
			// 		pdwDrvVer	hCõo[Wi[̈ւ̃|C^
			//			pdwDllVer	DLL̃o[Wi[̈ւ̃|C^
			// ߂l	 True
			//			s False
			//-------------------------------------------------------------------
			bool GetVersion(int* pdwDrvVer, int* pdwDllVer)
			{
				return Asb3000GetVersion(pdwDrvVer, pdwDllVer);
			}
			//-------------------------------------------------------------------
			// 		foCX̌
			// 		pwDeviceNo	gpfoCX̃foCXʔԍi[̈ւ
			//						|C^
			//			hWnd		DLLo郁bZ[W󂯎EBhẼnh
			//			uWMBase		o郁bZ[WID̃x[Xl
			// ߂l	 True
			//			s False
			//-------------------------------------------------------------------
			bool Create(short* pwDeviceNo, int hWnd, short uWMBase)
			{
				return Asb3000Create(pwDeviceNo, hWnd, uWMBase);
			}
			//-------------------------------------------------------------------
			// 		foCX̊J
			// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
			// ߂l	 True
			//			s False
			//-------------------------------------------------------------------
			bool Close(short wDeviceNo)
			{
				return Asb3000Close(wDeviceNo);
			}
			//-------------------------------------------------------------------
			// 		foCX̎擾
			// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
			//			pDevInfo	foCXi[\̂ւ̃|C^
			// ߂l	 True
			//			s False
			//-------------------------------------------------------------------
			bool GetDevInfo(short wDeviceNo, TDEVINFO% pDevInfo)
			{
				return Asb3000GetDevInfo(wDeviceNo, pDevInfo);
			}
			//-------------------------------------------------------------------
			// 		TCY̎擾
			// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
			//			pdwMemSize	Ă郁TCYi[̈ւ̃|C^
			// ߂l	 True
			//			s False
			//-------------------------------------------------------------------
			bool GetMemSize(short wDeviceNo, int* pdwMemSize)
			{
				return Asb3000GetMemSize(wDeviceNo, pdwMemSize);
			}
			//-------------------------------------------------------------------
			// 		TvO샂[h̐ݒ
			// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
			//			pSetMode	TvOp[^̃|C^
			// ߂l	 True
			//			s False
			//-------------------------------------------------------------------
			bool SetMode(short wDeviceNo, TSETMODE% pSetMode)
			{
				return Asb3000SetMode(wDeviceNo, pSetMode);
			}
			//-------------------------------------------------------------------
			// 		TvO̊Jn
			// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
			//			dwInitArg	\(0w)
			// ߂l	 True
			//			s False
			//-------------------------------------------------------------------
			bool StartSampling(short wDeviceNo, int dwInitArg)
			{
				return Asb3000StartSampling(wDeviceNo, dwInitArg);
			}
			//-------------------------------------------------------------------
			// 		TvO̒~
			// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
			// ߂l	 True
			//			s False
			//-------------------------------------------------------------------
			bool StopSampling(short wDeviceNo)
			{
				return Asb3000StopSampling(wDeviceNo);
			}
			//-------------------------------------------------------------------
			// 		TvOXe[^X擾
			// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
			//			pdwStatus	TvOXe[^X
			//			pdwNumData	ǃTvOf[^
			//			pvInitArg	\
			// ߂l	 True
			//			s False
			//-------------------------------------------------------------------
			bool GetStatus(short wDeviceNo, int* pdwStatus, int* pdwNumData, int* pvInitArg)
			{
				return Asb3000GetStatus(wDeviceNo, pdwStatus, pdwNumData, pvInitArg);
			}
			//-------------------------------------------------------------------
			// 		TvOf[^擾
			// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
			//			dwNumData	擾f[^
			//			pdwData		擾f[^i[̈ւ̃|C^
			// ߂l	 True
			//			s False
			//-------------------------------------------------------------------
			bool GetData(short wDeviceNo, int dwNumData, int* pData)
			{
				return Asb3000GetData(wDeviceNo, dwNumData, pData);
			}
			//-------------------------------------------------------------------
			// 		G[R[h̎擾
			// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
			// ߂l	G[R[h
			//-------------------------------------------------------------------
			int GetLastError(short wDeviceNo)
			{
				return Asb3000GetLastError(wDeviceNo);
			}
	};
}
